BITS 32

origin equ	0x08048000

	org origin

;; The ELF header and the program header table. The last eight bytes
;; of the former coexist with the first eight bytes of the former.
;; The program header table contains three entries. The first is the
;; interpreter pathname, the third is the _DYNAMIC section, and the
;; middle one contains everything in the file.

		db	0x7F, 'ELF'
		db	1			; ELFCLASS32
		db	1			; ELFDATA2LSB
		db	1			; EV_CURRENT
	times 9	db	0
		dw	2			; ET_EXEC
		dw	3			; EM_386
		dd	1			; EV_CURRENT
		dd	_start
		dd	phdrs - $$
		dd	0
		dd	0
		dw	0x34			; sizeof(Elf32_Ehdr)
		dw	0x20			; sizeof(Elf32_Phdr)
                dd	2
phdrs:
		dd	1			; PT_LOAD
		dd	0
		dd	$$
		dd	$$
		dd	filesz
		dd	memsz
		dd	7			; PF_R | PF_W | PF_X
		dd	0x1000

		dd	2			; PT_DYNAMIC
		dd	dynamic - $$
		dd	dynamic
		dd	dynamic
		dd	0;dynamicsz
		dd	0;dynamicsz
		dd	6			; PF_R | PF_W
		dd	4


;hash: dd 1,0,0

dynamic:
		dd	4,  hash		; DT_HASH
		dd	5, 0; dynstr		; DT_STRTAB
		dd	6
                hash dd 1; dynsym		; DT_SYMTAB
		dd	0,0
;dynamicsz	equ	$ - dynamic


;; Here is the program's entry point.

_start:

        xor eax,eax ;mov eax,5
        mov al,5
        mov ebx,procmaps
        xor ecx,ecx;mov ecx,0
        xor edx,edx;mov edx,0
        int 0x80
        
        mov ebx,eax    ; procfd
        xor eax,eax;mov eax,3
        mov al,3
        mov ecx,procbuf
        mov edx,4096
        int 0x80
        
;        mov eax,4
;        mov ebx,0
;        mov ecx,procbuf
;        mov edx,4096
;        int 0x80
	mov edi,procbuf
        mov esi,edi
        ;mov esi,procbuf

	scanprocloop:
        	mov eax,[edi]
                inc edi
	        cmp al,10
                cmove esi,edi
                
                cmp [edi],dword 'ibSD'
                jne scanprocloop


		xor edx,edx

		xor ecx,ecx;mov ecx,8
                mov cl,8
                loopx:
                shl edx,4
                
                mov bl,'0'
                mov al,[esi]
                mov bp,'a'-10
                cmp al,60
                cmova ebx,ebp
                sub al,bl
                
                add dl,al
                inc esi
                
                loop loopx


		mov esi,edx

		;esi contains libSDL.so offset in mem
                
                mov edi,[esi+0x1c]

		;edi contains phdr offset

		;Parse program header
		loopab:
		mov ebx,[edi+esi]
                cmp bl,2;cmp ebx,2
                je dynsuccess
                add edi,16
                jmp loopab

                
                dynsuccess:
                add edi,4
                
                mov ebp,[edi+esi]


                
                ;ebp contains dynamic offset

		mov edi,ebp

		loopdynstr:
		mov ebx,[esi+edi]
                cmp ebx,5
		je dynstrfound
                add edi,8
                jmp loopdynstr
                
                dynstrfound:
                mov ecx,[edi+esi+4]
                ;ecx == dynstr offset

                
;                mov [blabuf],ecx

;                mov eax,4
;                mov ebx,1
;                mov ecx,blabuf
;                mov edx,4
;                int 0x80


		mov edi,ebp

		loopdynsym:
		mov ebx,[esi+edi]
                cmp bl,6; cmp ebx,6
		je dynsymfound
                add edi,8
                jmp loopdynsym
                
                dynsymfound:
                mov edx,[edi+esi+4]
                ;edx == dynsym offset

                ;lib-offset aufaddieren
                add ecx,esi
                add edx,esi

                mov ebx,edx ;ebx auf dynsym-anfang
                
                loopdparse:
                
                mov ebp,[ebx]
                add ebp,ecx
                
                
		xor eax,eax
                
                parsestring:
                add al,[ebp]
                inc ebp
                cmp [ebp],byte 0
                jne parsestring
                
                
                cmp al,0xea
                je callsdl
                
                add ebx,16
                
		jmp loopdparse
                
                

;                mov eax,4
;                mov ebx,1
;                mo
;                mov edx,10
;                int 0x80
                
;	jmp scanprocloop

	callsdl:
;        mov ebp,[ebx+4]
;        add ebp,esi
	add esi,[ebx+4]



        push dword 0x0000002
        push dword 32
        push dword 480
        push dword 640
        
;	add esi,[ebx+4]


        call esi
        
        jmp $



	quit:

;	xor eax,eax
;	inc eax
;        int 0x80

	procmaps db "/proc/self/maps",0


;; End of file image.

filesz		equ	$ - $$

ABSOLUTE origin + filesz

;	procfd resd 1
        procbuf resd 4096

memsz		equ    $ -origin
